%global debug_package %{nil}
%global _binaries_in_noarch_packages_terminate_build   0
%global debug_level 1
%global _lto_cflags %{nil}

Summary:        Open-source legacy BIOS implementation
Name:           seabios
Version:        1.16.2
Release:        2%{?dist}
License:        LGPLv3
URL:            http://www.coreboot.org/SeaBIOS

Source0:        https://www.seabios.org/downloads/%{name}-%{version}.tar.gz

Patch3000:      0001-Workaround-for-a-win8.1-32-S4-resume-bug.patch
Patch3001:      0003-vgabios-Reorder-video-modes-to-work-around-a-Windows.patch

Source1:       config.vga-isavga
Source2:       config.vga-qxl
Source3:       config.vga-stdvga
Source4:       config.vga-vmware
Source5:       config.csm
Source6:       config.coreboot
Source7:       config.seabios-128k
Source8:       config.seabios-256k
Source9:       config.vga-virtio
Source10:       config.vga-ramfb
Source11:       config.vga-bochs-display
Source12:       config.vga-ati
Source13:       config.seabios-microvm
Source14:       config.vga-cirrus

BuildRequires: make gcc python3 iasl
ExclusiveArch: x86_64

Requires: %{name}-bin = %{version}-%{release}
Requires: seavgabios-bin = %{version}-%{release}

%description
SeaBIOS is an open-source legacy BIOS implementation which can be used as
a coreboot payload. It implements the standard BIOS calling interfaces
that a typical x86 proprietary BIOS implements.


%package bin
Summary: Seabios for x86
Buildarch: noarch


%description bin
SeaBIOS is an open-source legacy BIOS implementation which can be used as
a coreboot payload. It implements the standard BIOS calling interfaces
that a typical x86 proprietary BIOS implements.


%package -n seavgabios-bin
Summary: Seavgabios for x86
Buildarch: noarch

%description -n seavgabios-bin
SeaVGABIOS is an open-source VGABIOS implementation.


%prep
%autosetup -p1

%build
export CFLAGS="$RPM_OPT_FLAGS"
mkdir binaries

build_bios() {
    make clean distclean
    cp $1 .config
    echo "CONFIG_DEBUG_LEVEL=%{debug_level}" >> .config
    make oldnoconfig V=1

    make V=1 \
        EXTRAVERSION="-%{release}" \
        PYTHON=python3 \
        $4

    cp out/$2 binaries/$3
}

build_bios %{_sourcedir}/config.seabios-128k bios.bin bios.bin
build_bios %{_sourcedir}/config.seabios-256k bios.bin bios-256k.bin

%global vgaconfigs bochs-display cirrus isavga qxl stdvga ramfb vmware virtio ati
for config in %{vgaconfigs}; do
    build_bios %{_sourcedir}/config.vga-${config} \
               vgabios.bin vgabios-${config}.bin out/vgabios.bin
done


%install
mkdir -p %{buildroot}%{_datadir}/seabios
mkdir -p %{buildroot}%{_datadir}/seavgabios
install -m 0644 binaries/bios.bin %{buildroot}%{_datadir}/seabios/bios.bin
install -m 0644 binaries/bios-256k.bin %{buildroot}%{_datadir}/seabios/bios-256k.bin
install -m 0644 binaries/vgabios*.bin %{buildroot}%{_datadir}/seavgabios


%files
%license COPYING COPYING.LESSER
%doc README


%files bin
%dir %{_datadir}/seabios/
%{_datadir}/seabios/bios*.bin

%files -n seavgabios-bin
%dir %{_datadir}/seavgabios/
%{_datadir}/seavgabios/vgabios*.bin


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.16.2-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 11 2023 cunshunxia <cunshunxia@tencent.com> - 1.16.2-1
- upgrade to 1.16.2

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.16.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.16.0-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Dec 27 2022 cunshunxia <cunshunxia@tencent.com> - 1.16.0-1
- initial build
